// MapTool_3DView.cpp : implementation of the CMapTool_3DView class
//

#include "../../Source/MFC_Core/stdafx.h"
#include "MapTool_3D.h"

#include "MapTool_3DDoc.h"
#include "MapTool_3DView.h"
#include "../../Source/3D_Core/CCamera.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMapTool_3DView

IMPLEMENT_DYNCREATE(CMapTool_3DView, CView)

BEGIN_MESSAGE_MAP(CMapTool_3DView, CView)
	// Standard printing commands
	ON_WM_ENDSESSION()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

// CMapTool_3DView construction/destruction

CMapTool_3DView::CMapTool_3DView()
{
	// TODO: add construction code here

}

CMapTool_3DView::~CMapTool_3DView()
{
}

BOOL CMapTool_3DView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CMapTool_3DView printing

BOOL CMapTool_3DView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMapTool_3DView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMapTool_3DView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CMapTool_3DView diagnostics

#ifdef _DEBUG
void CMapTool_3DView::AssertValid() const
{
	CView::AssertValid();
}

void CMapTool_3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMapTool_3DDoc* CMapTool_3DView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMapTool_3DDoc)));
	return (CMapTool_3DDoc*)m_pDocument;
}
#endif //_DEBUG

// CMapTool_3DView message handlers

void CMapTool_3DView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	// 3D ʱȭ
	
	// Initialise the engine.
	HWND hWnd = GetSafeHwnd();
	CRect rc;
	GetWindowRect(rc);
	g_App.InitInstance(hWnd, rc);
  
}

// CMapTool_3DView drawing

void CMapTool_3DView::OnDraw(CDC* /*pDC*/)
{
	CMapTool_3DDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
	
	// TODO: add draw code for native data here
	// Begin the gameplay process. Will return when app due to exit.
	if(g_Option.Run)
	{
		g_App.FrameAdvance();
	}

	this->Invalidate(0);
}

void CMapTool_3DView::OnEndSession(BOOL bEnding)
{
	CView::OnEndSession(bEnding);

	// TODO: Add your message handler code here 
	// Shut down the engine, just to be polite, before exiting.
    if ( !g_App.ShutDown() )  MessageBox(L"Failed to shut system down correctly, please check file named 'debug.txt'.\r\n\r\nIf the problem persists, please contact technical support.", L"Non-Fatal Error");

}

void CMapTool_3DView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	bool isMin;
	nType == SIZE_MINIMIZED ? isMin = true : isMin = false; 
	CRect rc;
	GetWindowRect(rc);
//	g_App.SetSize(isMin, rc);			// ̴  ⼭ . (1)
}

void CMapTool_3DView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CView::OnLButtonDown(nFlags, point);
	g_App.Mouse_Lift_Down();
}

void CMapTool_3DView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CView::OnLButtonUp(nFlags, point);
	g_App.Mouse_Lift_Up();
}

