// MapTool_3DView.h : interface of the CMapTool_3DView class
//


#pragma once


class CMapTool_3DView : public CView
{
protected: // create from serialization only
	CMapTool_3DView();
	DECLARE_DYNCREATE(CMapTool_3DView)

// Attributes
public:
	CMapTool_3DDoc* GetDocument() const;

// Operations
public:

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CMapTool_3DView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual void OnInitialUpdate();
	afx_msg void OnEndSession(BOOL bEnding);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
};

#ifndef _DEBUG  // debug version in MapTool_3DView.cpp
inline CMapTool_3DDoc* CMapTool_3DView::GetDocument() const
   { return reinterpret_cast<CMapTool_3DDoc*>(m_pDocument); }
#endif

